// Copyright 2018 by Robert Dick.
// All rights reserved.

#include "RAlgo.h"
#include "RVector.h"

#include <algorithm>
#include <functional>
#include <string>
#include <cstring>
#include <iostream>

namespace rstd {
using namespace std;

/*###########################################################################*/
SearchHalt &
SearchHalt::operator|=(const SearchHalt sh) {
	val_ |= sh.val_;
	return *this;
}

/*===========================================================================*/
ostream &
operator<<(ostream & os, const SearchHalt & sh) {
	const char * prev = "";

	if (sh & SearchHalt::RANGE_LOW) {
		os << prev << "RANGE_LOW";
		prev = " ";
	}

	if (sh & SearchHalt::RANGE_HIGH) {
		os << prev << "RANGE_LOW";
		prev = " ";
	}

	if (sh & SearchHalt::TIMEOUT) {
		os << prev << "TIMEOUT";
		prev = " ";
	}

	if (sh & SearchHalt::NOISE) {
		os << prev << "NOISE";
		prev = " ";
	}

	if (sh & SearchHalt::MATCH) {
		os << prev << "MATCH";
		prev = " ";
	}

	if (sh & SearchHalt::GOOD) {
		os << prev << "GOOD";
		prev = " ";
	}

	return os;
}

}
