// Copyright 2018 by Robert Dick.
// All rights reserved.

#include "RVector.h"
#include "RPair.h"
#include "FVector.h"

#include <iostream>

namespace rstd {
using namespace std;

/*###########################################################################*/
template <int N, typename T = long> class Fred;

template <typename T>
struct Fred<2, T> : public FVector<2, T> {
	const T & type() const { return (*this)[0]; }
	const T & index() const { return (*this)[1]; }
};

template <typename T>
struct Fred<1, T> : public FVector<1, T> {
	const T & index() const { return (*this)[0]; }
};

/*===========================================================================*/
void RVector_test() {
	RVector<int> fred(5, 3);
	fred[2] = 4;
	for (int i = 0; i < fred.size(); ++i) {
		cout << fred[i];
	}
	cout << "\n";
}

}
