// Copyright 2018 by Robert Dick.
// All rights reserved.

#include "RecVector.h"

#include "RStd.h"

namespace rstd {
using namespace std;

/*###########################################################################*/
void RecVector_test() {
	RecVector2<int> fred(26, 32);
	fred(23, 2) = 5;
	Rassert(fred(23, 2) == 5);

	cout << "RecVector test\n";
	RecVector2<long> gene(3, 3);
	MAP(i, gene.size()[0]) {
		MAP(j, gene.size()[1]) {
			gene(i, j) = i + j;
			cout << gene(i, j) << " ";
		}
		cout << "\n";
	}

	gene.resize(5, 5, 9);
	MAP(i, gene.size()[0]) {
		MAP(j, gene.size()[1]) {
			cout << gene(i, j) << " ";
		}
		cout << "\n";
	}

	gene.resize(3, 3);
	MAP(i, gene.size()[0]) {
		MAP(j, gene.size()[1]) {
			cout << gene(i, j) << " ";
		}
		cout << "\n";
	}
}
}
